'----------------------------------------------
'   2313 oder was anderes als I2C Soft-Slave
'----------------------------------------------
'   PicNick was here  www.roboternetz.de
'----------------------------------------------
'   Das ist ein einfacher Sende- und Empfangs Slave
'----------------------------------------------
$crystal = 4000000                                ' Quarzfrequenz
$baud = 9600                                      'Baudrate fr RS232 (Gewohnheit)

$hwstack = 48
$swstack = 16
$framesize = 16

Const Tmr_c_prescale = 64
Const Tmr_c_preload = 191

Const Tmr_c_divis = 1000

Config Timer0 = Timer , Prescale = Tmr_c_prescale 'Timer 1mS
On Timer0 Interrupt_ticker                        ' Timer for Timer Queue

Dim Timeout As Byte
Dim Timediv As Word

'-------------------------------------
'  Pin-definition  I2C
'-------------------------------------
Config I2cdelay = 5
Config Scl = Portd.3                              'Ports fuer IIC-Bus
Config Sda = Portd.2

'---------------------------  Library und definitionen ------------------
$include "MyI2c.BAS"

'-------------------------------------
'  Address-definition RNBFRA
'-------------------------------------

Const Pwr_adr = &H74                              'I2C Adress Powerport
Const Out_adr = &H72                              'I2C Adress Out PCF
Const Exp_adr = &H7E                              'I2C Adress PCF Expansion

Const Co1_adr = &H68                              'I2C Adress 2313    I
Const Co1_adrr = &H69                             'I2C Adress 2313    I

Const Mn1_adr = &H6A                              'I2C Adress Atmega  I
Const Mn1_adrr = &H6B                             'I2C Adress Atmega  I

Const Co2_adr = &H6C                              'I2C Adress 2313   II
Const Co2_adrr = &H6D                             'I2C Adress 2313   II

Const Mn2_adr = &H6E                              'I2C Adress Atmega II
Const Mn2_adrr = &H6F                             'I2C Adress Atmega II

Dim Sent_flag As Byte

Dim M32_byte(24) As Byte                          'I2C Buffer Senden & empfangen

   Enable Timer0

   Enable Interrupts

'---------------------------------------------
'
'---------------------------------------------
   I2cinit                                        ' Bascom soll auch was tun

   I2c_write = Varptr(m32_byte(1));               ' Data receive-Buffer
   I2c_read = Varptr(m32_byte(1));                ' Data send-Buffer

   Do
         Loadadr I2c_flag , Z
         Gosub I2c_get_addr                       ' I2C Adresse read
         Select Case I2c_addr
         Case Co1_adr:
            Loadadr I2c_flag , Z
            Gosub I2c_slave_rx_data               ' daten empfangen bis Stop/Rep
            Sent_flag = 1
            '------------------------------------
            ' WORKOUT Message
            '------------------------------------

         Case Co1_adrr:
            Loadadr I2c_flag , Z
            Gosub I2c_slave_tx_byte               ' daten senden bis NAK

         Case Else
            I2cinit
         End Select

         If Sent_flag = 1  And Timeout = 1 Then
            Sent_flag = 0
            Timeout = 0
            Gosub Out_transmit
         End If


   Loop
End
'-----------------------------------------------------
Interrupt_ticker:
   Timer0 = Tmr_c_preload
   Incr Timediv
   If Timediv >= Tmr_c_divis Then
      Timeout = 1
      Timediv = 0
   End If
   Return
'-----------------------------------------------------
'
'-----------------------------------------------------
Out_transmit:
   Do
      Gosub I2cwaitbus                            ' wait for Bus
      $asm
      ldi   r17, out_adr
      !Call I2cwmaster                            ' send SLA+W  & arbitr.Check
      $end Asm
      If Err = 0 Then
            Loadadr M32_byte(1) , X
            $asm
            ld    r17, x+
            !Call I2cwmaster                      ' send data  & arbitr.Check
            $end Asm
      End If
      If Err = 0 Then
         I2cstop
      End If
   Loop Until Err = 0
   I2cinit
   Return

